#!/bin/sh

dir_this="/share/Apps/LinuxUtils"

func_stop()
{
	# close telnet
	killall -q telnetd
	
	# close ssh
	killall -q dropbear
	
	# close logger
	killall -q klogd
	killall -q syslogd
	
	# remove nano links
	rm -f  /bin/nano
	rm -f  /bin/rnano
	
	# remove mc links
	rm -f /usr/bin/mc
	rm -f /usr/bin/mcedit
	rm -f /usr/bin/mcview
	rm -f /usr/bin/mcmfmt

	# remove screen links
        rm -f /usr/bin/screen
	
	# remove e2fsprogs links
	rm -f /sbin/badblocks
	rm -f /sbin/dumpe2fs
	rm -f /sbin/e2freefrag
	rm -f /sbin/e2undo
	rm -f /sbin/filefrag
	rm -f /sbin/mklost+found
	rm -f /sbin/e2image
	rm -f /sbin/resize2fs
	rm -f /sbin/mke2fs
	rm -f /sbin/mkfs.ext2
	rm -f /sbin/mkfs.ext3
	rm -f /sbin/tune2fs
	rm -f /sbin/e2label
	rm -f /sbin/findfs
	rm -f /sbin/e2fsck
	rm -f /sbin/fsck.ext2
	rm -f /sbin/fsck.ext3
	rm -rf /etc/e2fsprogs
	
	# remove tpfsprogs links
	rm -f /sbin/dosfsck
	rm -f /sbin/fsck.msdos
	rm -f /sbin/fsck.vfat
	rm -f /sbin/chkntfs
	rm -f /sbin/fsck.ntfs
	rm -f /sbin/chkhfs
	rm -f /sbin/fsck.hfs
	rm -f /sbin/fsck.hfsplus
	
	# remove diskutil links
	rm -f /etc/smartd.conf
	rm -f /sbin/blkid
	rm -f /sbin/parted
	rm -f /sbin/partprobe
	rm -f /sbin/fdisk
	rm -f /sbin/hdparm
	rm -f /usr/bin/transfer-test
	rm -f /usr/bin/usb-devices
	rm -f /usr/sbin/lsusb
	rm -f /usr/sbin/sdparm
	rm -f /usr/sbin/smartd
	rm -f /usr/sbin/smartctl
	rm -f /usr/share/usb.ids
	rm -f /lib/libblkid.so.1
	rm -f /lib/libparted.so.0
	rm -f /lib/libuuid.so.1
	
	# remove dropbear links
	rm -f /usr/bin/dropbearkey
	rm -f /usr/bin/dropbearkeynew
	rm -f /usr/bin/dropbearconvert
	rm -f /usr/sbin/dropbear
	rm -f /usr/bin/dropbearmulti
	
	# restore busybox links
	rm -f /bin/busybox.ext
	rm -f /bin/ps
	rm -f /sbin/sysctl
	rm -f /usr/bin/top
	rm -f /usr/bin/nmeter
	rm -f /usr/bin/killall
	ln -s /bin/busybox /bin/ps
	ln -s /bin/busybox /sbin/sysctl
	ln -s /bin/busybox /sbin/fdisk
	ln -s /bin/busybox /sbin/hdparm
	ln -s /bin/busybox /usr/bin/top
	ln -s /bin/busybox /usr/bin/nmeter
	ln -s /bin/busybox /usr/bin/killall
	
	# unbind setups.cgi
	umount /opt/sybhttpd/default/setups.cgi 2>/dev/null
	umount /opt/sybhttpd/default/setups.cgi 2>/dev/null
}

func_start()
{
	# close telnet from syabas init.d
	killall -q telnetd
	
	# load config
	. "$dir_this/configure"
	
	# copy additional busybox binary
	cp -f "$dir_this/busybox/bin/busybox.ext" /bin
	chmod 775 /bin/busybox.ext
	
	# remove old busybox links
	rm /bin/ps
	rm /sbin/sysctl
	rm /usr/bin/top
	rm /usr/bin/nmeter
	rm /usr/bin/killall
	rm -f /usr/sbin/telnetd
	
	if [ $INSTALL_DISKUTILS -eq 1 ] ; then
		rm /sbin/fdisk
		rm /sbin/hdparm
	fi
	
	# create additional busybox symlinks
	/bin/busybox.ext --install -s
	
	if [ $INSTALL_DISKUTILS -eq 1 ] ; then
		dir_diskutils="$dir_this/diskutils"
		ln -s "$dir_diskutils/etc/smartd.conf" /etc/smartd.conf
		ln -s "$dir_diskutils/sbin/"* /sbin
		ln -s "$dir_diskutils/usr/bin/"* /usr/bin
		ln -s "$dir_diskutils/usr/sbin/"* /usr/sbin
		ln -s "$dir_diskutils/usr/share/usb.ids" /usr/share/usb.ids
		ln -s "$dir_diskutils/lib/libblkid.so.1.1.0" /lib/libblkid.so.1
		ln -s "$dir_diskutils/lib/libparted.so.0.0.1" /lib/libparted.so.0
		ln -s "$dir_diskutils/lib/libuuid.so.1.3.0" /lib/libuuid.so.1
	fi
	
	if [ $INSTALL_E2FSPROGS -eq 1 ] ; then
		dir_e2fsprogs="$dir_this/e2fsprogs"
		mkdir -p /etc/e2fsprogs
		cp -f "$dir_e2fsprogs/etc/mke2fs.conf" /etc/e2fsprogs
		ln -s "$dir_e2fsprogs/sbin/"* /sbin
		ln -s /sbin/mke2fs /sbin/mkfs.ext2
		ln -s /sbin/mke2fs /sbin/mkfs.ext3
		ln -s /sbin/e2fsck /sbin/fsck.ext2
		ln -s /sbin/e2fsck /sbin/fsck.ext3
		ln -s /sbin/tune2fs /sbin/e2label
		ln -s /sbin/tune2fs /sbin/findfs
	fi
	
	if [ $INSTALL_TPFSPROGS -eq 1 ] ; then
		dir_tpfsprogs="$dir_this/tpfsprogs"
		ln -s "$dir_tpfsprogs/sbin/"* /sbin
		ln -s /sbin/dosfsck /sbin/fsck.msdos
		ln -s /sbin/dosfsck /sbin/fsck.vfat
		ln -s /sbin/chkntfs /sbin/fsck.ntfs
		ln -s /sbin/chkhfs /sbin/fsck.hfs
		ln -s /sbin/chkhfs /sbin/fsck.hfsplus
	fi
	
	# link to internal wireless-tool
	ln -s "/opt/wifi/bin/iwconfig" /sbin/iwconfig 2>/dev/null
	ln -s "/opt/wifi/bin/iwpriv" /sbin/iwpriv 2>/dev/null
	
	# start system and kernel logger daemons
	if [ $START_LOGGER -ne 0 ] ; then
		file_logger="/tmp/messages"
		link_logger="$dir_this/log/messages"
		if [ $START_LOGGER -eq 2 ] ; then
			file_logger="$dir_this/log/messages.all"
			rm -f "$link_logger"
		fi
		touch "$file_logger"
		syslogd -O "$file_logger"
		klogd
		[ $START_LOGGER -ne 2 ] && [ ! -f "$link_logger" ] && ln -s "$file_logger" "$link_logger"
		
		# start smartd daemom, check SMART every 3 hour
		if [ $START_SMARTD -eq 1 ] && [ $INSTALL_DISKUTILS -eq 1 ] ; then
			smartd -i 10800
		fi
	fi
	
	if [ $TERMINAL_SERVER -ne 0 ] ; then
		# check PTY inside kernel
		if [ "`cat /proc/filesystems | grep devpts`" == "" ] ; then
			if [ "`lsmod | grep modpty`" == ""  ] ; then
				kernel_ver=`uname -r`
				dir_dest="/lib/modules/$kernel_ver/kernel/pty"
				mkdir -p "$dir_dest"
				for i in devpts-inode.ko modpty.ko ; do
					cp -f "$dir_this/pty/lib/kernel/$i" "$dir_dest"
					insmod "$dir_dest/$i"
				done
			fi
		fi
		
		# mount devpts
		if ! mountpoint -q /dev/pts ; then
			mount -t devpts devpts /dev/pts
		fi
		
		# allow securetty for ttyp0 ttyp1 ttyp2 ttyp3
		if [ "`grep 'ttyp0' /etc/securetty`" == "" ] ; then
			for i in 0 1 2 3 ; do
				echo "ttyp$i" >> /etc/securetty
			done
		fi
		
		# enable user root
		if [ "`grep 'root:/bin/sh' /etc/passwd`" == "" ] ; then
			sed "s|root:/bin/true$|root:/bin/sh|g" -i /etc/passwd
		fi
		
		# enable user nmt
		if [ "`grep 'nmt:/bin/sh' /etc/passwd`" == "" ] ; then
			sed "s|nmt:/bin/true$|nmt:/bin/sh|g" -i /etc/passwd
			mkdir -p /home/nmt
			chown nmt /home/nmt
			chgrp nmt /home/nmt
		fi
		
		# enable password for user nmt
		if [ "`grep '\^nmt:' /etc/shadow`" == "" ] ; then
			echo "nmt::10933:0:99999:7:::" >> /etc/shadow
		fi
		
		# add terminfo
		if [ "`grep 'export TERMINFO=' /etc/profile`" == "" ] ; then
			sed "s|export EDITOR='/bin/vi'|export EDITOR='/bin/nano'\n    export TERM='xterm'\n    export TERMINFO=/usr/share/terminfo|g" -i /etc/profile
		fi
		
		# add aliases
		if [ "`grep 'alias mc=' /etc/profile`" == "" ] ; then
			sed "s|alias df='df -h'|alias df='df -h'\n    alias mc='mc -c'\n    alias screen='screen -U'|g" -i /etc/profile
		fi
		
		# create system password for root
		if [ "$PASSWD_ROOT" != "" ] ; then
			echo "$PASSWD_ROOT" >  /tmp/.pwd_root
			echo "$PASSWD_ROOT" >> /tmp/.pwd_root
			cat /tmp/.pwd_root | passwd root >/dev/null
			rm -f /tmp/.pwd_root
		fi
		
		# create system password for nmt
		if [ "$PASSWD_NMT" != "" ] ; then
			echo "$PASSWD_NMT" >  /tmp/.pwd_nmt
			echo "$PASSWD_NMT" >> /tmp/.pwd_nmt
			cat /tmp/.pwd_nmt | passwd nmt >/dev/null
			rm -f /tmp/.pwd_nmt
		fi
		
		dir_ssh="$dir_this/ssh"
		cp -f "$dir_ssh/usr/bin/dropbearkeynew" /usr/bin
		cp -f "$dir_ssh/usr/bin/dropbearmulti" /usr/bin
		ln -s /usr/bin/dropbearmulti /usr/bin/dropbearkey
		ln -s /usr/bin/dropbearmulti /usr/bin/dropbearconvert
		ln -s /usr/bin/dropbearmulti /usr/sbin/dropbear
		
		if [ $TERMINAL_SERVER -eq 2 ] ; then
			mkdir -p /etc/dropbear
			cp -f "$dir_ssh/etc/dropbear/rsa_key" /etc/dropbear
			cp -f "$dir_ssh/etc/dropbear/dss_key" /etc/dropbear
			chmod 600 /etc/dropbear/rsa_key
			chmod 600 /etc/dropbear/dss_key
			
			# start dropbear ssh daemon
			touch /tmp/lastlog
			dropbear -r /etc/dropbear/rsa_key -d /etc/dropbear/dss_key
		else
			# start telnetd daemon
			telnetd -K -l login
		fi
		
		if [ $INSTALL_NANO -eq 1 ] ; then
			ln -s "$dir_this/nano/bin/"* /bin
			ln -s /bin/nano /bin/rnano
		fi
		
		if [ $INSTALL_MC -eq 1 ] ; then
			ln -s "$dir_this/mc/usr/bin/"* /usr/bin
			ln -s /usr/bin/mc /usr/bin/mcedit
			ln -s /usr/bin/mc /usr/bin/mcview
		fi
		
		if [ $INSTALL_SCREEN -eq 1 ] ; then
			ln -s "$dir_this/screen/usr/bin/screen" /usr/bin/screen
		fi
		
		# copy terminal call scripts
		cp -f "$dir_this/transmission/transmission-start" /usr/bin
		cp -f "$dir_this/transmission/transmission-stop" /usr/bin
		cp -f "$dir_this/copy_to_rootfs.sh" /usr/bin
	fi
	
	if [ $TUNE_APACHE -eq 1 ] ; then
		for i in "/nmt/apps/server/php5server/httpd.conf" "/nmt/apps/server/httpd.conf" ; do
			if [ -f "$i" ] ; then
				check_value=`grep \^StartServers "$i" | tr -s ' ' | cut -d ' ' -f 2`
				if [ "$check_value" != "1" ] ; then
					sed "s/\(MinSpareServers *\).*/\11/" -i "$i"
					sed "s/\(MaxSpareServers *\).*/\11/" -i "$i"
					sed "s/\(StartServers *\).*/\11/" -i "$i"
					sed "s/\(MaxClients *\).*/\15/" -i "$i"
					echo "Apache conf file $i tuned!"
				fi
			fi
		done
	fi
	
	if [ $FIX_TCP_RMEM -eq 1 ] ; then
		# rebind hacked setups.cgi (disable background changes tcp_rmem)
		umount /opt/sybhttpd/default/setups.cgi 2>/dev/null
		
		if [ -f "$dir_this/tcp_rmem/setups.cgi" ] ; then
			size_src=`stat -c %s "$dir_this/tcp_rmem/setups.cgi"`
			size_dst=`stat -c %s /opt/sybhttpd/default/setups.cgi`
			if [ "$size_src" == "$size_dst" ] ; then
				cp -f "$dir_this/tcp_rmem/setups.cgi" /tmp
				chmod 755 /tmp/setups.cgi
				mount -o bind /tmp/setups.cgi /opt/sybhttpd/default/setups.cgi
			else
				echo "FIX_TCP_RMEM FAILED! File setups.cgi has mismatch size. Different firmware?"
			fi
		fi
		
		# Load default, but fixed TCP receive window
		echo "16384 87380 87380" >/proc/sys/net/ipv4/tcp_rmem
	fi
	
	if [ -f "$dir_this/user.script.sh" ] ; then
		"$dir_this/user.script.sh"
	fi
}

case "$1" in
start)
	func_start
	;;
stop)
	func_stop
	;;
restart)
	func_stop
	sleep 1
	func_start
	;;
esac
