#!/bin/sh

# Manually copy important utils to rootfs (into RAM)
# Please execute this script under terminal before unmount /share drive for maintenance this drive
# Note: rootfs contents will be restored after mediaplayer reboot

dir_this="/share/Apps/LinuxUtils"

[ ! -d "$dir_this" ] && exit 1

# load config
. "$dir_this/configure"

if [ $INSTALL_DISKUTILS -eq 1 ] ; then
	dir_diskutils="$dir_this/diskutils"
	
	# copy lib's to rootfs
	cp -f "$dir_diskutils/lib/libblkid.so.1.1.0" /lib/libblkid.so.1
	cp -f "$dir_diskutils/lib/libparted.so.0.0.1" /lib/libparted.so.0
	cp -f "$dir_diskutils/lib/libuuid.so.1.3.0" /lib/libuuid.so.1
	
	# copy binaries to rootfs
	cp -f "$dir_diskutils/sbin/"* /sbin
fi

if [ $INSTALL_E2FSPROGS -eq 1 ] ; then
	dir_e2fsprogs="$dir_this/e2fsprogs"
	
	# copy binaries to rootfs
	cp -f "$dir_e2fsprogs/sbin/"* /sbin
fi

if [ $START_LOGGER -eq 2 ] ; then
	# close logger from /share path
	killall -q klogd
	killall -q syslogd
fi

echo "Done."
